// Begin of LDAP_Zeek (from "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap_zeek.spicy")
// Compiled by HILTI version 1.12.0-dev.188

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_ldap_hlto_scope;

namespace __hlt_ldap::LDAP {
    struct TlsForward;
    struct TlsForward : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<TlsForward> {
        auto __self() { return ::hilti::rt::ValueReference<TlsForward>::self(this); }
        std::optional<::hilti::rt::Bytes> chunk{};
        void __on_chunk(const ::hilti::rt::Bytes& __dd);
        void __on_0x25_init();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__TlsForward_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        TlsForward();
        TlsForward(const TlsForward&) = default;
        TlsForward(TlsForward&&) = default;
        TlsForward& operator=(const TlsForward&) = default;
        TlsForward& operator=(TlsForward&&) = default;
        TlsForward(std::optional<std::optional<::hilti::rt::Bytes>> chunk);
        template<typename F> void __visit(F _) const { _("chunk", chunk); }
    };

    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::TlsForward& x) -> std::ostream&;
    extern void __hook_TlsForward___on_chunk(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::TlsForward>& __self);
    extern void __hook_TlsForward___on_0x25_init(::hilti::rt::ValueReference<__hlt_ldap::LDAP::TlsForward>& __self);
}

namespace zeek::spicy::rt {
    extern void protocol_begin(const std::optional<std::string>& analyzer, const ::hilti::rt::Protocol& protocol);
}

namespace __hlt_ldap::LDAP_Zeek {
    extern void __hook_TlsForward___on_0x25_init_d0f3(::hilti::rt::ValueReference<LDAP::TlsForward>& __self);
}

namespace __hlt_ldap::LDAP {
    extern void __hook_TlsForward___on_0x25_init(::hilti::rt::ValueReference<LDAP::TlsForward>& __self);
}

namespace __hlt_ldap::LDAP_Zeek {
    extern void __hook_TlsForward___on_0x25_init_d0f3(::hilti::rt::ValueReference<LDAP::TlsForward>& __self);
}

namespace zeek::spicy::rt {
    extern auto is_orig() -> ::hilti::rt::Bool;
}

namespace zeek::spicy::rt {
    extern void protocol_data_in(const ::hilti::rt::Bool& is_orig, const ::hilti::rt::Bytes& data, const ::hilti::rt::Protocol& protocol);
}

namespace __hlt_ldap::LDAP_Zeek {
    extern void __hook_TlsForward___on_chunk_82f(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<LDAP::TlsForward>& __self);
}

namespace __hlt_ldap::LDAP {
    extern void __hook_TlsForward___on_chunk(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<LDAP::TlsForward>& __self);
}

namespace __hlt_ldap::LDAP_Zeek {
    extern void __hook_TlsForward___on_chunk_82f(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<LDAP::TlsForward>& __self);
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_ldap::LDAP_Zeek::__register_module)

inline void __hlt_ldap::LDAP::TlsForward::__on_0x25_init() {
    auto __self = LDAP::TlsForward::__self();
    return __hlt_ldap::LDAP::__hook_TlsForward___on_0x25_init(__self);
}

inline void __hlt_ldap::LDAP::TlsForward::__on_chunk(const ::hilti::rt::Bytes& __dd) {
    auto __self = LDAP::TlsForward::__self();
    return __hlt_ldap::LDAP::__hook_TlsForward___on_chunk(__dd, __self);
}

extern void __hlt_ldap::LDAP_Zeek::__hook_TlsForward___on_0x25_init_d0f3(::hilti::rt::ValueReference<LDAP::TlsForward>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap_zeek.spicy:7:3-7:29");
    ::zeek::spicy::rt::protocol_begin(std::optional<std::string>(std::string("SSL")), ::hilti::rt::Protocol{::hilti::rt::Protocol::TCP});
}

extern void __hlt_ldap::LDAP_Zeek::__hook_TlsForward___on_chunk_82f(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<LDAP::TlsForward>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap_zeek.spicy:11:3-11:53");
    ::zeek::spicy::rt::protocol_data_in(::zeek::spicy::rt::is_orig(), ::hilti::rt::optional::value((*__self).chunk), ::hilti::rt::Protocol{::hilti::rt::Protocol::TCP});
}

extern void __hlt_ldap::LDAP_Zeek::__register_module() { ::hilti::rt::detail::registerModule({ "LDAP_Zeek", __hlt_ldap_hlto_scope, nullptr, nullptr, nullptr, nullptr}); }
