// Begin of spicy_hooks_WebSocket (from "<root>")
// Compiled by HILTI version 1.12.0-dev.188

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_websocket_hlto_scope;

namespace __hlt_websocket::WebSocket {
    struct CloseFrame;
    struct Message;
    struct Frame;
    struct CloseFrame : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<CloseFrame> {
        auto __self() { return ::hilti::rt::ValueReference<CloseFrame>::self(this); }
        ::hilti::rt::integer::safe<uint16_t> status{};
        ::hilti::rt::Bytes reason{};
        void __on__anon_6(const ::hilti::rt::Bytes& __dd);
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_WebSocket__CloseFrame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        CloseFrame();
        CloseFrame(const CloseFrame&) = default;
        CloseFrame(CloseFrame&&) = default;
        CloseFrame& operator=(const CloseFrame&) = default;
        CloseFrame& operator=(CloseFrame&&) = default;
        CloseFrame(std::optional<::hilti::rt::integer::safe<uint16_t>> status, std::optional<::hilti::rt::Bytes> reason);
        template<typename F> void __visit(F _) const { _("status", status); _("reason", reason); }
    };

    struct Message : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Message> {
        auto __self() { return ::hilti::rt::ValueReference<Message>::self(this); }
        ::hilti::rt::Bool done{};
        ::hilti::rt::integer::safe<uint8_t> opcode{};
        std::optional<::hilti::rt::ValueReference<Frame>> first_frame{};
        void __on_first_frame(const ::hilti::rt::ValueReference<Frame>& __dd);
        void __on__anon_8_foreach(const ::hilti::rt::ValueReference<Frame>& __dd, ::hilti::rt::Bool& __stop);
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse__anon_8_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<Frame>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_WebSocket__Message_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Message();
        Message(const Message&) = default;
        Message(Message&&) = default;
        Message& operator=(const Message&) = default;
        Message& operator=(Message&&) = default;
        Message(std::optional<::hilti::rt::Bool> done, std::optional<::hilti::rt::integer::safe<uint8_t>> opcode, std::optional<std::optional<::hilti::rt::ValueReference<Frame>>> first_frame);
        template<typename F> void __visit(F _) const { _("done", done); _("opcode", opcode); _("first_frame", first_frame); }
    };

    struct Frame : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<Frame> {
        auto __self() { return ::hilti::rt::ValueReference<Frame>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> payload_len{};
        ::hilti::rt::integer::safe<uint64_t> masking_key_idx{};
        ::hilti::rt::Bytes close_data{};
        ::hilti::rt::integer::safe<uint8_t> effective_opcode{};
        std::optional<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>> _anon{};
        void __on__anon_3();
        std::optional<::hilti::rt::integer::safe<uint16_t>> payload_len2{};
        std::optional<::hilti::rt::integer::safe<uint64_t>> payload_len8{};
        void __on__anon_4();
        std::optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>> masking_key{};
        std::optional<::hilti::rt::Bytes> chunk{};
        void __on_chunk(const ::hilti::rt::Bytes& __dd);
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_masking_key_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_WebSocket__Frame_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_m{};
        Frame();
        Frame(const Frame&) = default;
        Frame(Frame&&) = default;
        Frame& operator=(const Frame&) = default;
        Frame& operator=(Frame&&) = default;
        Frame(std::optional<::hilti::rt::integer::safe<uint64_t>> payload_len, std::optional<::hilti::rt::integer::safe<uint64_t>> masking_key_idx, std::optional<::hilti::rt::Bytes> close_data, std::optional<::hilti::rt::integer::safe<uint8_t>> effective_opcode, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::Bool, ::hilti::rt::integer::safe<uint16_t>, ::hilti::rt::integer::safe<uint16_t>>>> _anon, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> payload_len2, std::optional<std::optional<::hilti::rt::integer::safe<uint64_t>>> payload_len8, std::optional<std::optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>>> masking_key, std::optional<std::optional<::hilti::rt::Bytes>> chunk);
        Frame(const ::hilti::rt::ValueReference<Message>& __p_m);
        template<typename F> void __visit(F _) const { _("payload_len", payload_len); _("masking_key_idx", masking_key_idx); _("close_data", close_data); _("effective_opcode", effective_opcode); _("<anon>", _anon); _("payload_len2", payload_len2); _("payload_len8", payload_len8); _("masking_key", masking_key); _("chunk", chunk); }
    };

}

namespace __hlt_websocket::spicy_hooks_WebSocket {
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_websocket_close_333f688f5861ad54 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_websocket_frame_37a627ea2d55fa36 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_websocket_frame_data_dce459ab7806ca52 = {};
    static std::optional<::zeek::EventHandlerPtr> __zeek_handler_websocket_message_600b762bc6fcd22e = {};
}

namespace __hlt_websocket::WebSocket {
    extern auto operator<<(std::ostream& o, const __hlt_websocket::WebSocket::CloseFrame& x) -> std::ostream&;
    extern void __hook_CloseFrame___on__anon_6(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::CloseFrame>& __self);
    extern void __hook_CloseFrame___on_0x25_done(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::CloseFrame>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_websocket::WebSocket::Message& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_websocket::WebSocket::Frame& x) -> std::ostream&;
    extern void __hook_Message___on_first_frame(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __self);
    extern void __hook_Message___on__anon_8_foreach(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __self);
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Message>& __self);
    extern void __hook_Frame___on__anon_3(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __self);
    extern void __hook_Frame___on__anon_4(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __self);
    extern void __hook_Frame___on_chunk(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __self);
    extern void __hook_Frame___on_0x25_done(::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __self);
}

namespace __hlt_websocket::spicy_hooks_WebSocket {
    extern void __hook_CloseFrame___on_0x25_done_ae9d(::hilti::rt::ValueReference<WebSocket::CloseFrame>& __self);
}

namespace __hlt_websocket::WebSocket {
    extern void __hook_CloseFrame___on_0x25_done(::hilti::rt::ValueReference<WebSocket::CloseFrame>& __self);
}

namespace __hlt_websocket::spicy_hooks_WebSocket {
    extern void __hook_CloseFrame___on_0x25_done_ae9d(::hilti::rt::ValueReference<WebSocket::CloseFrame>& __self);
    extern void __hook_Frame___on_0x25_done_8928(::hilti::rt::ValueReference<WebSocket::Frame>& __self);
}

namespace __hlt_websocket::WebSocket {
    extern void __hook_Frame___on_0x25_done(::hilti::rt::ValueReference<WebSocket::Frame>& __self);
}

namespace __hlt_websocket::spicy_hooks_WebSocket {
    extern void __hook_Frame___on_0x25_done_8928(::hilti::rt::ValueReference<WebSocket::Frame>& __self);
    extern void __hook_Frame___on_chunk_e61a(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<WebSocket::Frame>& __self);
}

namespace __hlt_websocket::WebSocket {
    extern void __hook_Frame___on_chunk(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<WebSocket::Frame>& __self);
}

namespace __hlt_websocket::spicy_hooks_WebSocket {
    extern void __hook_Frame___on_chunk_e61a(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<WebSocket::Frame>& __self);
    extern void __hook_Message___on_0x25_done_56f(::hilti::rt::ValueReference<WebSocket::Message>& __self);
}

namespace __hlt_websocket::WebSocket {
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<WebSocket::Message>& __self);
}

namespace __hlt_websocket::spicy_hooks_WebSocket {
    extern void __hook_Message___on_0x25_done_56f(::hilti::rt::ValueReference<WebSocket::Message>& __self);
    extern void __init_globals(::hilti::rt::Context* ctx);
    extern void __destroy_globals(::hilti::rt::Context* ctx);
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_websocket::spicy_hooks_WebSocket::__register_module)

inline void __hlt_websocket::WebSocket::CloseFrame::__on_0x25_done() {
    auto __self = WebSocket::CloseFrame::__self();
    return __hlt_websocket::WebSocket::__hook_CloseFrame___on_0x25_done(__self);
}

inline void __hlt_websocket::WebSocket::CloseFrame::__on__anon_6(const ::hilti::rt::Bytes& __dd) {
    auto __self = WebSocket::CloseFrame::__self();
    return __hlt_websocket::WebSocket::__hook_CloseFrame___on__anon_6(__dd, __self);
}

inline void __hlt_websocket::WebSocket::Frame::__on_0x25_done() {
    auto __self = WebSocket::Frame::__self();
    return __hlt_websocket::WebSocket::__hook_Frame___on_0x25_done(__self);
}

inline void __hlt_websocket::WebSocket::Frame::__on__anon_3() {
    auto __self = WebSocket::Frame::__self();
    return __hlt_websocket::WebSocket::__hook_Frame___on__anon_3(__self);
}

inline void __hlt_websocket::WebSocket::Frame::__on__anon_4() {
    auto __self = WebSocket::Frame::__self();
    return __hlt_websocket::WebSocket::__hook_Frame___on__anon_4(__self);
}

inline void __hlt_websocket::WebSocket::Frame::__on_chunk(const ::hilti::rt::Bytes& __dd) {
    auto __self = WebSocket::Frame::__self();
    return __hlt_websocket::WebSocket::__hook_Frame___on_chunk(__dd, __self);
}

inline void __hlt_websocket::WebSocket::Message::__on_0x25_done() {
    auto __self = WebSocket::Message::__self();
    return __hlt_websocket::WebSocket::__hook_Message___on_0x25_done(__self);
}

inline void __hlt_websocket::WebSocket::Message::__on__anon_8_foreach(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd, ::hilti::rt::Bool& __stop) {
    auto __self = WebSocket::Message::__self();
    return __hlt_websocket::WebSocket::__hook_Message___on__anon_8_foreach(__dd, __stop, __self);
}

inline void __hlt_websocket::WebSocket::Message::__on_first_frame(const ::hilti::rt::ValueReference<__hlt_websocket::WebSocket::Frame>& __dd) {
    auto __self = WebSocket::Message::__self();
    return __hlt_websocket::WebSocket::__hook_Message___on_first_frame(__dd, __self);
}

extern void __hlt_websocket::spicy_hooks_WebSocket::__destroy_globals(::hilti::rt::Context* ctx) {
    ::__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_close_333f688f5861ad54.reset();;
    ::__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_37a627ea2d55fa36.reset();;
    ::__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_data_dce459ab7806ca52.reset();;
    ::__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_message_600b762bc6fcd22e.reset();;
}

extern void __hlt_websocket::spicy_hooks_WebSocket::__hook_CloseFrame___on_0x25_done_ae9d(::hilti::rt::ValueReference<WebSocket::CloseFrame>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:16");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_close_333f688f5861ad54))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:16");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:16");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{4U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).status, ::zeek::spicy::rt::event_arg_type((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_close_333f688f5861ad54), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).reason, ::zeek::spicy::rt::event_arg_type((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_close_333f688f5861ad54), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    ::zeek::spicy::rt::raise_event((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_close_333f688f5861ad54), std::move(args));
}

extern void __hlt_websocket::spicy_hooks_WebSocket::__hook_Frame___on_0x25_done_8928(::hilti::rt::ValueReference<WebSocket::Frame>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:14");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_37a627ea2d55fa36))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:14");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:14");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{6U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*__self)._anon).value))), ::zeek::spicy::rt::event_arg_type((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_37a627ea2d55fa36), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    args.emplace_back(::zeek::spicy::rt::to_val((::hilti::rt::optional::value(std::get<1>(::hilti::rt::optional::value((*__self)._anon).value))), ::zeek::spicy::rt::event_arg_type((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_37a627ea2d55fa36), ::hilti::rt::integer::safe<std::uint64_t>{3U})));
    args.emplace_back(::zeek::spicy::rt::to_val((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*__self)._anon).value))), ::zeek::spicy::rt::event_arg_type((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_37a627ea2d55fa36), ::hilti::rt::integer::safe<std::uint64_t>{4U})));
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).payload_len, ::zeek::spicy::rt::event_arg_type((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_37a627ea2d55fa36), ::hilti::rt::integer::safe<std::uint64_t>{5U})));
    ::zeek::spicy::rt::raise_event((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_37a627ea2d55fa36), std::move(args));
}

extern void __hlt_websocket::spicy_hooks_WebSocket::__hook_Frame___on_chunk_e61a(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<WebSocket::Frame>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:18");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_data_dce459ab7806ca52))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:18");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:18");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val(::hilti::rt::optional::value((*__self).chunk), ::zeek::spicy::rt::event_arg_type((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_data_dce459ab7806ca52), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_data_dce459ab7806ca52), std::move(args));
}

extern void __hlt_websocket::spicy_hooks_WebSocket::__hook_Message___on_0x25_done_56f(::hilti::rt::ValueReference<WebSocket::Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:12");
    if ( ! (::zeek::spicy::rt::have_handler((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_message_600b762bc6fcd22e))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:12");
        return;
    }

    ::hilti::rt::Vector<::zeek::ValPtr> args;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/websocket/websocket.evt:12");
    args.reserve(::hilti::rt::integer::safe<std::uint64_t>{3U});
    args.emplace_back(::zeek::spicy::rt::current_conn());
    args.emplace_back(::zeek::spicy::rt::current_is_orig());
    args.emplace_back(::zeek::spicy::rt::to_val((*__self).opcode, ::zeek::spicy::rt::event_arg_type((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_message_600b762bc6fcd22e), ::hilti::rt::integer::safe<std::uint64_t>{2U})));
    ::zeek::spicy::rt::raise_event((*__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_message_600b762bc6fcd22e), std::move(args));
}

extern void __hlt_websocket::spicy_hooks_WebSocket::__init_globals(::hilti::rt::Context* ctx) {
    ::__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_close_333f688f5861ad54 = ::zeek::spicy::rt::internal_handler(std::string("websocket_close"));
    ::__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_37a627ea2d55fa36 = ::zeek::spicy::rt::internal_handler(std::string("websocket_frame"));
    ::__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_frame_data_dce459ab7806ca52 = ::zeek::spicy::rt::internal_handler(std::string("websocket_frame_data"));
    ::__hlt_websocket::spicy_hooks_WebSocket::__zeek_handler_websocket_message_600b762bc6fcd22e = ::zeek::spicy::rt::internal_handler(std::string("websocket_message"));
}

extern void __hlt_websocket::spicy_hooks_WebSocket::__register_module() { ::hilti::rt::detail::registerModule({ "spicy_hooks_WebSocket", __hlt_websocket_hlto_scope, nullptr, &__init_globals, &__destroy_globals, nullptr}); }
