// Begin of Finger (from "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy")
// Compiled by HILTI version 1.12.0-dev.188

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>

extern const char* __hlt_finger_hlto_scope;

namespace __hlt_finger::Finger {
    struct ReplyLine;
    struct Reply;
    struct Request;
    struct ReplyLine : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ReplyLine> {
        auto __self() { return ::hilti::rt::ValueReference<ReplyLine>::self(this); }
        std::optional<std::string> data{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_Finger__ReplyLine_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ReplyLine();
        ReplyLine(const ReplyLine&) = default;
        ReplyLine(ReplyLine&&) = default;
        ReplyLine& operator=(const ReplyLine&) = default;
        ReplyLine& operator=(ReplyLine&&) = default;
        ReplyLine(std::optional<std::optional<std::string>> data);
        template<typename F> void __visit(F _) const { _("data", data); }
    };

    struct Reply : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Reply> {
        auto __self() { return ::hilti::rt::ValueReference<Reply>::self(this); }
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Reply>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse__anon_7_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<ReplyLine>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_Finger__Reply_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Reply();
        Reply(const Reply&) = default;
        Reply(Reply&&) = default;
        Reply& operator=(const Reply&) = default;
        Reply& operator=(Reply&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct Request : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Request> {
        auto __self() { return ::hilti::rt::ValueReference<Request>::self(this); }
        void __on__anon_2(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures);
        std::optional<std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>> arg{};
        void __on_arg(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures);
        std::string user{};
        std::string host{};
        ::hilti::rt::Bool whois{};
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Request>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_Finger__Request_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Request();
        Request(const Request&) = default;
        Request(Request&&) = default;
        Request& operator=(const Request&) = default;
        Request& operator=(Request&&) = default;
        Request(std::optional<std::optional<std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>>> arg, std::optional<std::string> user, std::optional<std::string> host, std::optional<::hilti::rt::Bool> whois);
        template<typename F> void __visit(F _) const { _("arg", arg); _("user", user); _("host", host); _("whois", whois); }
    };

    const ::hilti::rt::RegExp __ctor__regexp_6 = ::hilti::rt::RegExp(std::string{"[^\\r\\n]*{#2}"}, {.no_sub = true});
    const ::hilti::rt::RegExp __ctor__regexp_4 = ::hilti::rt::RegExp(std::string{"[^\\r\\n]*"}, {});
    const ::hilti::rt::RegExp __ctor__regexp_5 = ::hilti::rt::RegExp(std::string{"\\r?\\n"}, {});
    const ::hilti::rt::RegExp __ctor__regexp = ::hilti::rt::RegExp(std::string{"[ \\t]*"}, {});
    const ::hilti::rt::RegExp __ctor__regexp_2 = ::hilti::rt::RegExp(std::string{"/W{#1}"}, {.no_sub = true});
    const ::hilti::rt::RegExp __ctor__regexp_3 = ::hilti::rt::RegExp(std::string{"/W"}, {});
    const ::hilti::rt::RegExp NewLine = ::hilti::rt::RegExp(std::string{"\\r?\\n"}, {});
    const ::hilti::rt::RegExp OptionalWhiteSpace = ::hilti::rt::RegExp(std::string{"[ \\t]*"}, {});
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Reply0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Reply0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Reply0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Reply0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Reply0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Reply0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Reply0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Reply0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40ReplyLine0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40ReplyLine0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40ReplyLine0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40ReplyLine0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40ReplyLine0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40ReplyLine0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40ReplyLine0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40ReplyLine0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Request0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Request0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Request0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Request0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Request0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Request0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Request0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25Finger0x400x40Request0x25uses_sync_advance = ::hilti::rt::Bool(false);
    extern auto operator<<(std::ostream& o, const __hlt_finger::Finger::ReplyLine& x) -> std::ostream&;
    extern void __hook_ReplyLine___on_0x25_done(::hilti::rt::ValueReference<__hlt_finger::Finger::ReplyLine>& __self);
    ReplyLine::ReplyLine() {
    }

    ReplyLine::ReplyLine(std::optional<std::optional<std::string>> data) : ReplyLine() {
        if ( data ) this->data = std::move(*data);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_finger::Finger::Reply& x) -> std::ostream&;
    Reply::Reply() {
    }

    
}

namespace hlt_finger::Finger::Reply {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_finger::Finger::Reply>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace spicy::rt {
    extern void accept_input();
}

namespace __hlt_finger::Finger {
    extern void __hook_ReplyLine___on_0x25_done_1d1f(::hilti::rt::ValueReference<ReplyLine>& __self);
    extern void __hook_ReplyLine___on_0x25_done(::hilti::rt::ValueReference<ReplyLine>& __self);
    extern void __hook_ReplyLine___on_0x25_done_1d1f(::hilti::rt::ValueReference<ReplyLine>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_finger::Finger::Request& x) -> std::ostream&;
    extern void __hook_Request___on__anon_2(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<__hlt_finger::Finger::Request>& __self);
    extern void __hook_Request___on_arg(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<__hlt_finger::Finger::Request>& __self);
    extern void __hook_Request___on_0x25_done(::hilti::rt::ValueReference<__hlt_finger::Finger::Request>& __self);
    Request::Request() {
        whois = ::hilti::rt::Bool(false);
    }

    Request::Request(std::optional<std::optional<std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>>> arg, std::optional<std::string> user, std::optional<std::string> host, std::optional<::hilti::rt::Bool> whois) : Request() {
        if ( arg ) this->arg = std::move(*arg);
        if ( user ) this->user = std::move(*user);
        if ( host ) this->host = std::move(*host);
        if ( whois ) this->whois = std::move(*whois);
    }

    
    extern void __hook_Request___on_0x25_done_d69d(::hilti::rt::ValueReference<Request>& __self);
    extern void __hook_Request___on_0x25_done(::hilti::rt::ValueReference<Request>& __self);
    extern void __hook_Request___on_0x25_done_d69d(::hilti::rt::ValueReference<Request>& __self);
    extern void __hook_Request___on__anon_2_b204(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<Request>& __self);
    extern void __hook_Request___on__anon_2(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<Request>& __self);
    extern void __hook_Request___on__anon_2_b204(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<Request>& __self);
    extern void __hook_Request___on_arg_6e5c(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<Request>& __self);
    extern void __hook_Request___on_arg(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<Request>& __self);
    extern void __hook_Request___on_arg_6e5c(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<Request>& __self);
}

namespace hlt_finger::Finger::Request {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_finger::Finger::Request>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_finger::Finger {
    extern void __register_Finger_Reply();
    extern void __register_Finger_ReplyLine();
    extern void __register_Finger_Request();
    extern void __init_module();
    extern void __register_module();
}

namespace __hlt_finger::type_info { namespace {
    extern const ::hilti::rt::TypeInfo __ti_Finger__ReplyLine_namex2aFinger__ReplyLinex2b;
    extern const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b;
    const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b = { "hilti::RecoverableFailure", "hilti::RecoverableFailure", new ::hilti::rt::type_info::Exception() };
    const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b = { {}, "optional<spicy::RecoverableFailure>", new ::hilti::rt::type_info::Optional(&type_info::__ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b, ::hilti::rt::type_info::Optional::accessor<::hilti::rt::RecoverableFailure>()) };
    const ::hilti::rt::TypeInfo __ti_Finger__ReplyLine_namex2aFinger__ReplyLinex2b = { "Finger::ReplyLine", "Finger::ReplyLine", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "data", &::hilti::rt::type_info::string, offsetof(Finger::ReplyLine, data), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(Finger::ReplyLine, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_Finger__Reply_namex2aFinger__Replyx2b;
    const ::hilti::rt::TypeInfo __ti_Finger__Reply_namex2aFinger__Replyx2b = { "Finger::Reply", "Finger::Reply", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(Finger::Reply, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_Finger__Request_namex2aFinger__Requestx2b;
    extern const ::hilti::rt::TypeInfo __ti_tuple_const_bytes__const_bytes__tuplex2abytes_bytes_x2b;
    const ::hilti::rt::TypeInfo __ti_tuple_const_bytes__const_bytes__tuplex2abytes_bytes_x2b = { {}, "tuple<const bytes, const bytes>", new ::hilti::rt::type_info::Tuple(std::vector<::hilti::rt::type_info::tuple::Element>({::hilti::rt::type_info::tuple::Element{ "", &::hilti::rt::type_info::bytes, ::hilti::rt::tuple::elementOffset<std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>, 0>() }, ::hilti::rt::type_info::tuple::Element{ "", &::hilti::rt::type_info::bytes, ::hilti::rt::tuple::elementOffset<std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>, 1>() }})) };
    const ::hilti::rt::TypeInfo __ti_Finger__Request_namex2aFinger__Requestx2b = { "Finger::Request", "Finger::Request", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "arg", &type_info::__ti_tuple_const_bytes__const_bytes__tuplex2abytes_bytes_x2b, offsetof(Finger::Request, arg), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>>() }, ::hilti::rt::type_info::struct_::Field{ "user", &::hilti::rt::type_info::string, offsetof(Finger::Request, user), false, false }, ::hilti::rt::type_info::struct_::Field{ "host", &::hilti::rt::type_info::string, offsetof(Finger::Request, host), false, false }, ::hilti::rt::type_info::struct_::Field{ "whois", &::hilti::rt::type_info::bool_, offsetof(Finger::Request, whois), false, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(Finger::Request, __error), true, false }})) };
} }

HILTI_PRE_INIT(__hlt_finger::Finger::__register_module)

auto __hlt_finger::Finger::Reply::__parse_Finger__Reply_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Reply::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:54:21-56:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Vector<__hlt_finger::Finger::ReplyLine> __transient__anon_7;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:55:5-55:18");
    ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};

    // Begin parsing production: While: _anon_7 -> while(<look-ahead-found>): Resolved_4;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse__anon_7_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error, __transient__anon_7);
    // End parsing production: While: _anon_7 -> while(<look-ahead-found>): Resolved_4;

    ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_finger::Finger::Reply::__parse__anon_7_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_finger::Finger::ReplyLine>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Reply::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:55:5-55:18");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ::hilti::rt::Bool(true) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_1;
        ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_1=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        if ( ! (::hilti::rt::Bool(static_cast<bool>(__lah))) ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_2;
            if ( ::spicy::rt::detail::atEod(__data, __cur, (__lhs_2=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
            }
            else {
                ::hilti::rt::stream::View ncur = __cur;
                for ( ::hilti::rt::regexp::MatchState ms = __hlt_finger::Finger::__ctor__regexp_6.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
                    ::hilti::rt::integer::safe<int32_t> rc;
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:55:5-55:18");
                    std::tie(rc, ncur) = ms.advance(ncur);
                    if ( ::hilti::rt::integer::safe<int32_t> __x = rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
                        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_3;
                        if ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, (__lhs_3=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                            continue;
                        }

                        __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
                        __lahe = __cur.begin();
                        break;
                    }

                    else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
                        ::spicy::rt::detail::printParserState(std::string_view("Finger::Reply"), __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, std::string_view("default"), __trim, __error);
                        __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
                        __lahe = __cur.begin();
                        break;
                    }

                    else  {
                        __lah = ::hilti::rt::integer::safe<int64_t>(rc);
                        __lahe = ncur.begin();
                        break;
                    }
                }

                ::spicy::rt::detail::printParserState(std::string_view("Finger::Reply"), __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, std::string_view("default"), __trim, __error);
            }
        }

        if ( ::hilti::rt::integer::safe<int64_t> __x = __lah; __x == ::hilti::rt::integer::safe<std::int64_t>{-1} ) {
            break;
        }

        else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{2} ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_4;
            ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
            ::hilti::rt::ValueReference<__hlt_finger::Finger::ReplyLine> __elem;
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:43:18-52:1");

            // Begin parsing production: Unit: Finger__ReplyLine_2 -> data_2 _anon_5_2 (container '_anon_7');
            __elem = (__hlt_finger::Finger::ReplyLine());
            std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: Finger__ReplyLine_2 -> data_2 _anon_5_2 (container '_anon_7');

            ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
            if ( ! (__stop) ) {
            }

            if ( __stop ) {
                break;
            }

            if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_4=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:55:5-55:18");
                throw ::spicy::rt::ParseError(std::string_view("loop body did not change input position, possible infinite loop"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:55:5-55:18");
            }
        }

        else  {
            break;
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_finger::Finger::Reply::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Reply::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:54:21-56:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_Finger__Reply_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_finger::Finger::Reply::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:54:21-56:1");
    ::hilti::rt::ValueReference<__hlt_finger::Finger::Reply> __unit = ::hilti::rt::reference::make_value<__hlt_finger::Finger::Reply>((__hlt_finger::Finger::Reply()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:54:21-56:1");

    // Begin parsing production: Unit: Finger__Reply -> _anon_7;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: Finger__Reply -> _anon_7;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_finger::Finger::Reply::parse2(::hilti::rt::ValueReference<__hlt_finger::Finger::Reply>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:54:21-56:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:54:21-56:1");

    // Begin parsing production: Unit: Finger__Reply -> _anon_7;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: Finger__Reply -> _anon_7;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_finger::Finger::Reply::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:54:21-56:1");
    ::hilti::rt::ValueReference<__hlt_finger::Finger::Reply> __unit = ::hilti::rt::reference::make_value<__hlt_finger::Finger::Reply>((__hlt_finger::Finger::Reply()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_Finger__Reply_namex2aFinger__Replyx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:54:21-56:1");

    // Begin parsing production: Unit: Finger__Reply -> _anon_7;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: Finger__Reply -> _anon_7;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_finger::Finger::ReplyLine::__on_0x25_done() {
    auto __self = Finger::ReplyLine::__self();
    return __hlt_finger::Finger::__hook_ReplyLine___on_0x25_done(__self);
}

auto __hlt_finger::Finger::ReplyLine::__parse_Finger__ReplyLine_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ReplyLine::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:43:18-52:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:44:11-44:20");
        ::hilti::rt::Bytes __parsed_data;
        ::hilti::rt::Vector<::hilti::rt::Bytes> __captures;

        // Begin parsing production: Ctor: data -> /[^\r\n]*/ (regexp);
        if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
            if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{2} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:44:11-44:20");
                throw ::spicy::rt::ParseError(std::string_view("unexpected token to consume"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:44:11-44:20");
            }

            __parsed_data = __cur.sub(__lahe).data();
            __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            __cur = __cur.advance(__lahe);
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }
        }
        else {
            ::hilti::rt::stream::View __ncur = __cur;
            for ( ::hilti::rt::regexp::MatchState ms = __hlt_finger::Finger::__ctor__regexp_4.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
                ::hilti::rt::integer::safe<int32_t> __rc;
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:44:11-44:20");
                std::tie(__rc, __ncur) = ms.advance(__ncur);
                if ( ::hilti::rt::integer::safe<int32_t> __x = __rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
                    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_5;
                    // NOLINTNEXTLINE(clang-analyzer-deadcode.DeadStores);
                    ::spicy::rt::detail::waitForInputOrEod(__data, __ncur, (__lhs_5=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
                    continue;
                }

                else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:44:11-44:20");
                    throw ::spicy::rt::ParseError(std::string_view("failed to match regular expression"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:44:11-44:20");
                }

                else  {
                    __captures = ms.captures(__cur);
                    __parsed_data = __cur.sub(__ncur.begin()).data();
                    __cur = __ncur;
                    if ( __trim ) {
                        (*__data).trim(__cur.begin());
                    }

                    break;
                }
            }
        }

        // End parsing production: Ctor: data -> /[^\r\n]*/ (regexp);

        {
            ::hilti::rt::Bytes __dd = __parsed_data;
            ::hilti::rt::optional::valueOrInit((*__self).data) = __dd.decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
        }

    }

    ::hilti::rt::Bytes __transient__anon_5;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:11:17-11:23");
    ::hilti::rt::Vector<::hilti::rt::Bytes> __captures;

    // Begin parsing production: Ctor: _anon_5 -> /\r?\n/ (regexp);
    ::hilti::rt::stream::View __ncur = __cur;
    for ( ::hilti::rt::regexp::MatchState ms = __hlt_finger::Finger::__ctor__regexp_5.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
        ::hilti::rt::integer::safe<int32_t> __rc;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:11:17-11:23");
        std::tie(__rc, __ncur) = ms.advance(__ncur);
        if ( ::hilti::rt::integer::safe<int32_t> __x = __rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_6;
            // NOLINTNEXTLINE(clang-analyzer-deadcode.DeadStores);
            ::spicy::rt::detail::waitForInputOrEod(__data, __ncur, (__lhs_6=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            continue;
        }

        else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:11:17-11:23");
            throw ::spicy::rt::ParseError(std::string_view("failed to match regular expression"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:11:17-11:23");
        }

        else  {
            __captures = ms.captures(__cur);
            __transient__anon_5 = __cur.sub(__ncur.begin()).data();
            __cur = __ncur;
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            break;
        }
    }

    // End parsing production: Ctor: _anon_5 -> /\r?\n/ (regexp);

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:43:18-52:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_finger::Finger::ReplyLine::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ReplyLine::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:43:18-52:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_Finger__ReplyLine_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_finger::Finger::Request::__on_0x25_done() {
    auto __self = Finger::Request::__self();
    return __hlt_finger::Finger::__hook_Request___on_0x25_done(__self);
}

inline void __hlt_finger::Finger::Request::__on__anon_2(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures) {
    auto __self = Finger::Request::__self();
    return __hlt_finger::Finger::__hook_Request___on__anon_2(__dd, __captures, __self);
}

inline void __hlt_finger::Finger::Request::__on_arg(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures) {
    auto __self = Finger::Request::__self();
    return __hlt_finger::Finger::__hook_Request___on_arg(__dd, __captures, __self);
}

auto __hlt_finger::Finger::Request::__parse_Finger__Request_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Request::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:13:23-41:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Bytes __transient__anon;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:10:28-10:35");
    ::hilti::rt::Vector<::hilti::rt::Bytes> __captures;

    // Begin parsing production: Ctor: _anon -> /[ \t]*/ (regexp);
    ::hilti::rt::stream::View __ncur = __cur;
    for ( ::hilti::rt::regexp::MatchState ms = __hlt_finger::Finger::__ctor__regexp.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
        ::hilti::rt::integer::safe<int32_t> __rc;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:10:28-10:35");
        std::tie(__rc, __ncur) = ms.advance(__ncur);
        if ( ::hilti::rt::integer::safe<int32_t> __x = __rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_7;
            // NOLINTNEXTLINE(clang-analyzer-deadcode.DeadStores);
            ::spicy::rt::detail::waitForInputOrEod(__data, __ncur, (__lhs_7=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            continue;
        }

        else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:10:28-10:35");
            throw ::spicy::rt::ParseError(std::string_view("failed to match regular expression"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:10:28-10:35");
        }

        else  {
            __captures = ms.captures(__cur);
            __transient__anon = __cur.sub(__ncur.begin()).data();
            __cur = __ncur;
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            break;
        }
    }

    // End parsing production: Ctor: _anon -> /[ \t]*/ (regexp);

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:20:9-20:18");

    // Begin parsing production: LookAhead: switch_lha_2 -> {Ctor: _anon_2 -> //W/ (regexp) (id 1)}: switch_case_1 | {Variable: _anon_3 -> void (not a literal)}: switch_case_2;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_lha_2_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: LookAhead: switch_lha_2 -> {Ctor: _anon_2 -> //W/ (regexp) (id 1)}: switch_case_1 | {Variable: _anon_3 -> void (not a literal)}: switch_case_2;

    ::hilti::rt::Bytes __transient__anon_4;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:10:28-10:35");
    ::hilti::rt::Vector<::hilti::rt::Bytes> __captures_2;

    // Begin parsing production: Ctor: _anon_4 -> /[ \t]*/ (regexp);
    ::hilti::rt::stream::View __ncur_2 = __cur;
    for ( ::hilti::rt::regexp::MatchState ms = __hlt_finger::Finger::__ctor__regexp.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
        ::hilti::rt::integer::safe<int32_t> __rc;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:10:28-10:35");
        std::tie(__rc, __ncur_2) = ms.advance(__ncur_2);
        if ( ::hilti::rt::integer::safe<int32_t> __x = __rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_8;
            // NOLINTNEXTLINE(clang-analyzer-deadcode.DeadStores);
            ::spicy::rt::detail::waitForInputOrEod(__data, __ncur_2, (__lhs_8=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            continue;
        }

        else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:10:28-10:35");
            throw ::spicy::rt::ParseError(std::string_view("failed to match regular expression"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:10:28-10:35");
        }

        else  {
            __captures_2 = ms.captures(__cur);
            __transient__anon_4 = __cur.sub(__ncur_2.begin()).data();
            __cur = __ncur_2;
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            break;
        }
    }

    // End parsing production: Ctor: _anon_4 -> /[ \t]*/ (regexp);

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:25:10-25:19");
        ::hilti::rt::Bytes __parsed_arg;
        ::hilti::rt::Vector<::hilti::rt::Bytes> __captures;

        // Begin parsing production: Ctor: arg -> /[^\r\n]*/ (regexp);
        if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
            if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{2} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:25:10-25:19");
                throw ::spicy::rt::ParseError(std::string_view("unexpected token to consume"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:25:10-25:19");
            }

            __parsed_arg = __cur.sub(__lahe).data();
            __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            __cur = __cur.advance(__lahe);
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }
        }
        else {
            ::hilti::rt::stream::View __ncur = __cur;
            for ( ::hilti::rt::regexp::MatchState ms = __hlt_finger::Finger::__ctor__regexp_4.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
                ::hilti::rt::integer::safe<int32_t> __rc;
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:25:10-25:19");
                std::tie(__rc, __ncur) = ms.advance(__ncur);
                if ( ::hilti::rt::integer::safe<int32_t> __x = __rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
                    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_9;
                    // NOLINTNEXTLINE(clang-analyzer-deadcode.DeadStores);
                    ::spicy::rt::detail::waitForInputOrEod(__data, __ncur, (__lhs_9=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
                    continue;
                }

                else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:25:10-25:19");
                    throw ::spicy::rt::ParseError(std::string_view("failed to match regular expression"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:25:10-25:19");
                }

                else  {
                    __captures = ms.captures(__cur);
                    __parsed_arg = __cur.sub(__ncur.begin()).data();
                    __cur = __ncur;
                    if ( __trim ) {
                        (*__data).trim(__cur.begin());
                    }

                    break;
                }
            }
        }

        // End parsing production: Ctor: arg -> /[^\r\n]*/ (regexp);

        {
            ::hilti::rt::Bytes __dd = __parsed_arg;
            ::hilti::rt::optional::valueOrInit((*__self).arg) = __dd.strip().split1("@"_b);
        }

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:25:5-31:5");
        (*__self).__on_arg(::hilti::rt::optional::value((*__self).arg), __captures);
        __error = (*__self).__error;
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:13:23-41:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent(std::string_view("spicy"));
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_finger::Finger::Request::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Request::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:13:23-41:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_Finger__Request_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_finger::Finger::Request::__parse_switch_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Request::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:20:9-20:18");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    if ( ! (::hilti::rt::Bool(static_cast<bool>(__lah))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_10;
        if ( ::spicy::rt::detail::atEod(__data, __cur, (__lhs_10=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
        }
        else {
            ::hilti::rt::stream::View ncur = __cur;
            for ( ::hilti::rt::regexp::MatchState ms = __hlt_finger::Finger::__ctor__regexp_2.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
                ::hilti::rt::integer::safe<int32_t> rc;
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:20:9-20:18");
                std::tie(rc, ncur) = ms.advance(ncur);
                if ( ::hilti::rt::integer::safe<int32_t> __x = rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
                    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_11;
                    if ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, (__lhs_11=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                        continue;
                    }

                    __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
                    __lahe = __cur.begin();
                    break;
                }

                else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
                    ::spicy::rt::detail::printParserState(std::string_view("Finger::Request"), __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, std::string_view("default"), __trim, __error);
                    __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
                    __lahe = __cur.begin();
                    break;
                }

                else  {
                    __lah = ::hilti::rt::integer::safe<int64_t>(rc);
                    __lahe = ncur.begin();
                    break;
                }
            }

            ::spicy::rt::detail::printParserState(std::string_view("Finger::Request"), __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, std::string_view("default"), __trim, __error);
        }
    }

    if ( ::hilti::rt::integer::safe<int64_t> __x = __lah; __x == ::hilti::rt::integer::safe<std::int64_t>{1} ) {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:17:9-19:9");

        // Begin parsing production: Block: switch_case_1 -> _anon_2;
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        ::hilti::rt::Bytes __transient__anon_2;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:17:14-17:18");
        ::hilti::rt::Vector<::hilti::rt::Bytes> __captures;

        // Begin parsing production: Ctor: _anon_2 -> //W/ (regexp);
        if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
            if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{1} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:17:14-17:18");
                throw ::spicy::rt::ParseError(std::string_view("unexpected token to consume"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:17:14-17:18");
            }

            __transient__anon_2 = __cur.sub(__lahe).data();
            __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            __cur = __cur.advance(__lahe);
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }
        }
        else {
            ::hilti::rt::stream::View __ncur = __cur;
            for ( ::hilti::rt::regexp::MatchState ms = __hlt_finger::Finger::__ctor__regexp_3.tokenMatcher(); ::hilti::rt::Bool(true);  ) {
                ::hilti::rt::integer::safe<int32_t> __rc;
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:17:14-17:18");
                std::tie(__rc, __ncur) = ms.advance(__ncur);
                if ( ::hilti::rt::integer::safe<int32_t> __x = __rc; __x == ::hilti::rt::integer::safe<std::int32_t>{-1} ) {
                    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_12;
                    // NOLINTNEXTLINE(clang-analyzer-deadcode.DeadStores);
                    ::spicy::rt::detail::waitForInputOrEod(__data, __ncur, (__lhs_12=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
                    continue;
                }

                else if ( __x == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:17:14-17:18");
                    throw ::spicy::rt::ParseError(std::string_view("failed to match regular expression"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:17:14-17:18");
                }

                else  {
                    __captures = ms.captures(__cur);
                    __transient__anon_2 = __cur.sub(__ncur.begin()).data();
                    __cur = __ncur;
                    if ( __trim ) {
                        (*__data).trim(__cur.begin());
                    }

                    break;
                }
            }
        }

        // End parsing production: Ctor: _anon_2 -> //W/ (regexp);

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:17:12-19:9");
        (*__self).__on__anon_2(__transient__anon_2, __captures);
        __error = (*__self).__error;
        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_case_1 -> _anon_2;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{-1} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:20:9-20:18");
        throw ::spicy::rt::ParseError(std::string_view("expected look-ahead token, but reached end-of-data"), "/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:20:9-20:18");
    }

    else  {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:20:9-20:18");

        // Begin parsing production: Block: switch_case_2 -> _anon_3;
        ::hilti::rt::debug::indent(std::string_view("spicy"));
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:20:14-20:17");

        // Begin parsing production: Variable: _anon_3 -> void;
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_3 -> void;

        ::hilti::rt::debug::dedent(std::string_view("spicy"));
        // End parsing production: Block: switch_case_2 -> _anon_3;
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_finger::Finger::Request::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:13:23-41:1");
    ::hilti::rt::ValueReference<__hlt_finger::Finger::Request> __unit = ::hilti::rt::reference::make_value<__hlt_finger::Finger::Request>((__hlt_finger::Finger::Request()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:13:23-41:1");

    // Begin parsing production: Unit: Finger__Request -> _anon switch_lha_2 _anon_4 arg;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: Finger__Request -> _anon switch_lha_2 _anon_4 arg;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_finger::Finger::Request::parse2(::hilti::rt::ValueReference<__hlt_finger::Finger::Request>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:13:23-41:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:13:23-41:1");

    // Begin parsing production: Unit: Finger__Request -> _anon switch_lha_2 _anon_4 arg;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: Finger__Request -> _anon switch_lha_2 _anon_4 arg;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_finger::Finger::Request::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:13:23-41:1");
    ::hilti::rt::ValueReference<__hlt_finger::Finger::Request> __unit = ::hilti::rt::reference::make_value<__hlt_finger::Finger::Request>((__hlt_finger::Finger::Request()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_Finger__Request_namex2aFinger__Requestx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:13:23-41:1");

    // Begin parsing production: Unit: Finger__Request -> _anon switch_lha_2 _anon_4 arg;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: Finger__Request -> _anon switch_lha_2 _anon_4 arg;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt(std::string_view("successful synchronization never confirmed: %s"), ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern void __hlt_finger::Finger::__hook_ReplyLine___on_0x25_done_1d1f(::hilti::rt::ValueReference<ReplyLine>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:48:9-50:34");
    if ( ::hilti::rt::string::size(::hilti::rt::optional::value((*__self).data)) > ::hilti::rt::integer::safe<std::uint64_t>{10U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:50:13-50:33");
        ::spicy::rt::accept_input();
    }
}

extern void __hlt_finger::Finger::__hook_Request___on_0x25_done_d69d(::hilti::rt::ValueReference<Request>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:34:9-35:34");
    if ( (std::get<0>(::hilti::rt::optional::value((*__self).arg)).size() > ::hilti::rt::integer::safe<std::uint64_t>{0U}) || ((*__self).whois) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:35:13-35:33");
        ::spicy::rt::accept_input();
    }
}

extern void __hlt_finger::Finger::__hook_Request___on__anon_2_b204(const ::hilti::rt::Bytes& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<Request>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:18:13-18:29");
    (*__self).whois = ::hilti::rt::Bool(true);
}

extern void __hlt_finger::Finger::__hook_Request___on_arg_6e5c(const std::tuple<::hilti::rt::Bytes, ::hilti::rt::Bytes>& __dd, const ::hilti::rt::Vector<::hilti::rt::Bytes>& __captures, ::hilti::rt::ValueReference<Request>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:27:9-27:40");
    (*__self).user = std::get<0>(::hilti::rt::optional::value((*__self).arg)).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:29:9-30:45");
    if ( std::get<1>(::hilti::rt::optional::value((*__self).arg)).size() > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/finger/finger.spicy:30:13-30:44");
        (*__self).host = std::get<1>(::hilti::rt::optional::value((*__self).arg)).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
    }
}

extern void __hlt_finger::Finger::__init_module() {
    __hlt_finger::Finger::__register_Finger_Reply();
    __hlt_finger::Finger::__register_Finger_ReplyLine();
    __hlt_finger::Finger::__register_Finger_Request();
}

extern void __hlt_finger::Finger::__register_Finger_Reply() {
    ::hilti::rt::detail::checkStack();
    Finger::Reply::__parser = ::spicy::rt::Parser(std::string_view("Finger::Reply"), ::hilti::rt::Bool(true), hlt_finger::Finger::Reply::parse1, hlt_finger::Finger::Reply::parse2, hlt_finger::Finger::Reply::parse3, ::hilti::rt::Null(), &type_info::__ti_Finger__Reply_namex2aFinger__Replyx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(Finger::Reply::__parser, std::string(__hlt_finger_hlto_scope), ::hilti::rt::StrongReference<__hlt_finger::Finger::Reply>());
}

extern void __hlt_finger::Finger::__register_Finger_ReplyLine() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_finger::Finger::__register_Finger_Request() {
    ::hilti::rt::detail::checkStack();
    Finger::Request::__parser = ::spicy::rt::Parser(std::string_view("Finger::Request"), ::hilti::rt::Bool(true), hlt_finger::Finger::Request::parse1, hlt_finger::Finger::Request::parse2, hlt_finger::Finger::Request::parse3, ::hilti::rt::Null(), &type_info::__ti_Finger__Request_namex2aFinger__Requestx2b, std::string(""), ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(Finger::Request::__parser, std::string(__hlt_finger_hlto_scope), ::hilti::rt::StrongReference<__hlt_finger::Finger::Request>());
}

extern void __hlt_finger::Finger::__register_module() { ::hilti::rt::detail::registerModule({ "Finger", __hlt_finger_hlto_scope, &__init_module, nullptr, nullptr, nullptr}); }

extern auto __hlt_finger::Finger::operator<<(std::ostream& o, const __hlt_finger::Finger::ReplyLine& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_finger::Finger::operator<<(std::ostream& o, const __hlt_finger::Finger::Reply& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_finger::Finger::operator<<(std::ostream& o, const __hlt_finger::Finger::Request& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto hlt_finger::Finger::Reply::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_finger::Finger::Reply::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_finger::Finger::Reply::parse2(::hilti::rt::ValueReference<__hlt_finger::Finger::Reply>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_finger::Finger::Reply::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_finger::Finger::Reply::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_finger::Finger::Reply::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_finger::Finger::Request::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_finger::Finger::Request::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_finger::Finger::Request::parse2(::hilti::rt::ValueReference<__hlt_finger::Finger::Request>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_finger::Finger::Request::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_finger::Finger::Request::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_finger::Finger::Request::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

