// Begin of PostgreSQL_Zeek (from "/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql_zeek.spicy")
// Compiled by HILTI version 1.12.0-dev.188

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_postgresql_hlto_scope;

namespace __hlt_postgresql::PostgreSQL {
    struct AuthenticationRequest;
    struct AuthenticationResponse;
    struct BackendKeyData;
    struct DataRow;
    struct ErrorIdentifiedField;
    struct ErrorResponse;
    struct NotImplemented;
    struct NoticeIdentifiedField;
    struct NoticeResponse;
    struct ParameterStatus;
    struct ReadyForQuery;
    struct BackendMessage;
    struct Context;
    struct SimpleQuery;
    struct Terminate;
    struct FrontendMessage;
    struct MaybeBackendSSL;
    struct ProtocolVersion;
    struct SSLSink;
    struct StartupParameter;
    struct StartupMessage;
    HILTI_RT_ENUM_WITH_DEFAULT(SSLBackendState, Undef, S = 0, N = 1, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(SSLFrontendState, Undef, Requested = 0, NotRequested = 1, Undef = -1);;
    struct AuthenticationRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<AuthenticationRequest> {
        auto __self() { return ::hilti::rt::ValueReference<AuthenticationRequest>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint32_t>> identifier{};
        void __on_identifier(const ::hilti::rt::integer::safe<uint32_t>& __dd);
        std::optional<::hilti::rt::Bytes> data{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__AuthenticationRequest_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint32_t> __p_length{};
        AuthenticationRequest();
        AuthenticationRequest(const AuthenticationRequest&) = default;
        AuthenticationRequest(AuthenticationRequest&&) = default;
        AuthenticationRequest& operator=(const AuthenticationRequest&) = default;
        AuthenticationRequest& operator=(AuthenticationRequest&&) = default;
        AuthenticationRequest(std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> identifier, std::optional<std::optional<::hilti::rt::Bytes>> data);
        AuthenticationRequest(const ::hilti::rt::integer::safe<uint32_t>& __p_length);
        template<typename F> void __visit(F _) const { _("identifier", identifier); _("data", data); }
    };

    struct AuthenticationResponse : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<AuthenticationResponse> {
        auto __self() { return ::hilti::rt::ValueReference<AuthenticationResponse>::self(this); }
        std::optional<::hilti::rt::Bytes> data{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__AuthenticationResponse_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        AuthenticationResponse();
        AuthenticationResponse(const AuthenticationResponse&) = default;
        AuthenticationResponse(AuthenticationResponse&&) = default;
        AuthenticationResponse& operator=(const AuthenticationResponse&) = default;
        AuthenticationResponse& operator=(AuthenticationResponse&&) = default;
        AuthenticationResponse(std::optional<std::optional<::hilti::rt::Bytes>> data);
        template<typename F> void __visit(F _) const { _("data", data); }
    };

    struct BackendKeyData : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<BackendKeyData> {
        auto __self() { return ::hilti::rt::ValueReference<BackendKeyData>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint32_t>> process_id{};
        std::optional<::hilti::rt::integer::safe<uint32_t>> secret_key{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__BackendKeyData_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        BackendKeyData();
        BackendKeyData(const BackendKeyData&) = default;
        BackendKeyData(BackendKeyData&&) = default;
        BackendKeyData& operator=(const BackendKeyData&) = default;
        BackendKeyData& operator=(BackendKeyData&&) = default;
        BackendKeyData(std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> process_id, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> secret_key);
        template<typename F> void __visit(F _) const { _("process_id", process_id); _("secret_key", secret_key); }
    };

    struct DataRow : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<DataRow> {
        auto __self() { return ::hilti::rt::ValueReference<DataRow>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint16_t>> column_values{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__DataRow_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        DataRow();
        DataRow(const DataRow&) = default;
        DataRow(DataRow&&) = default;
        DataRow& operator=(const DataRow&) = default;
        DataRow& operator=(DataRow&&) = default;
        DataRow(std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> column_values);
        template<typename F> void __visit(F _) const { _("column_values", column_values); }
    };

    struct ErrorIdentifiedField : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ErrorIdentifiedField> {
        auto __self() { return ::hilti::rt::ValueReference<ErrorIdentifiedField>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> code{};
        std::optional<::hilti::rt::Bytes> value{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ErrorIdentifiedField_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ErrorIdentifiedField();
        ErrorIdentifiedField(const ErrorIdentifiedField&) = default;
        ErrorIdentifiedField(ErrorIdentifiedField&&) = default;
        ErrorIdentifiedField& operator=(const ErrorIdentifiedField&) = default;
        ErrorIdentifiedField& operator=(ErrorIdentifiedField&&) = default;
        ErrorIdentifiedField(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> code, std::optional<std::optional<::hilti::rt::Bytes>> value);
        template<typename F> void __visit(F _) const { _("code", code); _("value", value); }
    };

    struct ErrorResponse : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ErrorResponse> {
        auto __self() { return ::hilti::rt::ValueReference<ErrorResponse>::self(this); }
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse__anon_22_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<ErrorIdentifiedField>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ErrorResponse_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ErrorResponse();
        ErrorResponse(const ErrorResponse&) = default;
        ErrorResponse(ErrorResponse&&) = default;
        ErrorResponse& operator=(const ErrorResponse&) = default;
        ErrorResponse& operator=(ErrorResponse&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct NotImplemented : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<NotImplemented> {
        auto __self() { return ::hilti::rt::ValueReference<NotImplemented>::self(this); }
        std::optional<::hilti::rt::Bytes> chunk{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__NotImplemented_5_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint8_t> __p_typ{};
        NotImplemented();
        NotImplemented(const NotImplemented&) = default;
        NotImplemented(NotImplemented&&) = default;
        NotImplemented& operator=(const NotImplemented&) = default;
        NotImplemented& operator=(NotImplemented&&) = default;
        NotImplemented(std::optional<std::optional<::hilti::rt::Bytes>> chunk);
        NotImplemented(const ::hilti::rt::integer::safe<uint8_t>& __p_typ);
        template<typename F> void __visit(F _) const { _("chunk", chunk); }
    };

    struct NoticeIdentifiedField : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<NoticeIdentifiedField> {
        auto __self() { return ::hilti::rt::ValueReference<NoticeIdentifiedField>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> code{};
        std::optional<::hilti::rt::Bytes> value{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__NoticeIdentifiedField_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        NoticeIdentifiedField();
        NoticeIdentifiedField(const NoticeIdentifiedField&) = default;
        NoticeIdentifiedField(NoticeIdentifiedField&&) = default;
        NoticeIdentifiedField& operator=(const NoticeIdentifiedField&) = default;
        NoticeIdentifiedField& operator=(NoticeIdentifiedField&&) = default;
        NoticeIdentifiedField(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> code, std::optional<std::optional<::hilti::rt::Bytes>> value);
        template<typename F> void __visit(F _) const { _("code", code); _("value", value); }
    };

    struct NoticeResponse : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<NoticeResponse> {
        auto __self() { return ::hilti::rt::ValueReference<NoticeResponse>::self(this); }
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse__anon_18_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<NoticeIdentifiedField>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__NoticeResponse_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        NoticeResponse();
        NoticeResponse(const NoticeResponse&) = default;
        NoticeResponse(NoticeResponse&&) = default;
        NoticeResponse& operator=(const NoticeResponse&) = default;
        NoticeResponse& operator=(NoticeResponse&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct ParameterStatus : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ParameterStatus> {
        auto __self() { return ::hilti::rt::ValueReference<ParameterStatus>::self(this); }
        std::optional<::hilti::rt::Bytes> name{};
        std::optional<::hilti::rt::Bytes> value{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ParameterStatus_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ParameterStatus();
        ParameterStatus(const ParameterStatus&) = default;
        ParameterStatus(ParameterStatus&&) = default;
        ParameterStatus& operator=(const ParameterStatus&) = default;
        ParameterStatus& operator=(ParameterStatus&&) = default;
        ParameterStatus(std::optional<std::optional<::hilti::rt::Bytes>> name, std::optional<std::optional<::hilti::rt::Bytes>> value);
        template<typename F> void __visit(F _) const { _("name", name); _("value", value); }
    };

    struct ReadyForQuery : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ReadyForQuery> {
        auto __self() { return ::hilti::rt::ValueReference<ReadyForQuery>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> transaction_status{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ReadyForQuery_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ReadyForQuery();
        ReadyForQuery(const ReadyForQuery&) = default;
        ReadyForQuery(ReadyForQuery&&) = default;
        ReadyForQuery& operator=(const ReadyForQuery&) = default;
        ReadyForQuery& operator=(ReadyForQuery&&) = default;
        ReadyForQuery(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> transaction_status);
        template<typename F> void __visit(F _) const { _("transaction_status", transaction_status); }
    };

    struct BackendMessage : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<BackendMessage> {
        auto __self() { return ::hilti::rt::ValueReference<BackendMessage>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> typ{};
        std::optional<::hilti::rt::integer::safe<uint32_t>> length{};
        std::optional<::hilti::rt::ValueReference<BackendKeyData>> backend_key_data{};
        std::optional<::hilti::rt::ValueReference<ErrorResponse>> error{};
        std::optional<::hilti::rt::ValueReference<AuthenticationRequest>> auth{};
        std::optional<::hilti::rt::ValueReference<ParameterStatus>> parameter_status{};
        std::optional<::hilti::rt::ValueReference<DataRow>> data_row{};
        std::optional<::hilti::rt::ValueReference<ReadyForQuery>> ready_for_query{};
        std::optional<::hilti::rt::ValueReference<NoticeResponse>> notice{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> not_implemented{};
        void __on_0x25_error(const std::string& __except);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_4_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__BackendMessage_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        BackendMessage();
        BackendMessage(const BackendMessage&) = default;
        BackendMessage(BackendMessage&&) = default;
        BackendMessage& operator=(const BackendMessage&) = default;
        BackendMessage& operator=(BackendMessage&&) = default;
        BackendMessage(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> typ, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> length, std::optional<std::optional<::hilti::rt::ValueReference<BackendKeyData>>> backend_key_data, std::optional<std::optional<::hilti::rt::ValueReference<ErrorResponse>>> error, std::optional<std::optional<::hilti::rt::ValueReference<AuthenticationRequest>>> auth, std::optional<std::optional<::hilti::rt::ValueReference<ParameterStatus>>> parameter_status, std::optional<std::optional<::hilti::rt::ValueReference<DataRow>>> data_row, std::optional<std::optional<::hilti::rt::ValueReference<ReadyForQuery>>> ready_for_query, std::optional<std::optional<::hilti::rt::ValueReference<NoticeResponse>>> notice, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> not_implemented);
        template<typename F> void __visit(F _) const { _("typ", typ); _("length", length); _("backend_key_data", backend_key_data); _("error", error); _("auth", auth); _("parameter_status", parameter_status); _("data_row", data_row); _("ready_for_query", ready_for_query); _("notice", notice); _("not_implemented", not_implemented); }
    };

    struct Context : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Context> {
        auto __self() { return ::hilti::rt::ValueReference<Context>::self(this); }
        PostgreSQL::SSLFrontendState ssl_frontend_state{};
        PostgreSQL::SSLBackendState ssl_backend_state{};
        ::hilti::rt::StrongReference<::spicy::rt::Sink> ssl_sink{};
        ::hilti::rt::Bool ssl_sink_connected{};
        Context();
        Context(const Context&) = default;
        Context(Context&&) = default;
        Context& operator=(const Context&) = default;
        Context& operator=(Context&&) = default;
        Context(std::optional<PostgreSQL::SSLFrontendState> ssl_frontend_state, std::optional<PostgreSQL::SSLBackendState> ssl_backend_state, std::optional<::hilti::rt::StrongReference<::spicy::rt::Sink>> ssl_sink, std::optional<::hilti::rt::Bool> ssl_sink_connected);
        template<typename F> void __visit(F _) const { _("ssl_frontend_state", ssl_frontend_state); _("ssl_backend_state", ssl_backend_state); _("ssl_sink", ssl_sink); _("ssl_sink_connected", ssl_sink_connected); }
    };

    struct SimpleQuery : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<SimpleQuery> {
        auto __self() { return ::hilti::rt::ValueReference<SimpleQuery>::self(this); }
        std::optional<::hilti::rt::Bytes> query{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__SimpleQuery_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        SimpleQuery();
        SimpleQuery(const SimpleQuery&) = default;
        SimpleQuery(SimpleQuery&&) = default;
        SimpleQuery& operator=(const SimpleQuery&) = default;
        SimpleQuery& operator=(SimpleQuery&&) = default;
        SimpleQuery(std::optional<std::optional<::hilti::rt::Bytes>> query);
        template<typename F> void __visit(F _) const { _("query", query); }
    };

    struct Terminate : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Terminate> {
        auto __self() { return ::hilti::rt::ValueReference<Terminate>::self(this); }
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__Terminate_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Terminate();
        Terminate(const Terminate&) = default;
        Terminate(Terminate&&) = default;
        Terminate& operator=(const Terminate&) = default;
        Terminate& operator=(Terminate&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct FrontendMessage : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<FrontendMessage> {
        auto __self() { return ::hilti::rt::ValueReference<FrontendMessage>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> typ{};
        std::optional<::hilti::rt::integer::safe<uint32_t>> length{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> not_implemented{};
        void __on_0x25_error(const std::string& __except);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__FrontendMessage_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        FrontendMessage();
        FrontendMessage(const FrontendMessage&) = default;
        FrontendMessage(FrontendMessage&&) = default;
        FrontendMessage& operator=(const FrontendMessage&) = default;
        FrontendMessage& operator=(FrontendMessage&&) = default;
        FrontendMessage(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> typ, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> length, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> not_implemented);
        template<typename F> void __visit(F _) const { _("typ", typ); _("length", length); _("not_implemented", not_implemented); }
    };

    struct MaybeBackendSSL : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<MaybeBackendSSL> {
        auto __self() { return ::hilti::rt::ValueReference<MaybeBackendSSL>::self(this); }
        ::hilti::rt::StrongReference<::spicy::rt::Sink> s1{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> ssl_byte{};
        void __on_ssl_byte(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        inline static ::spicy::rt::Parser __parser{};
        ::spicy::rt::sink::detail::State* __sink{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<MaybeBackendSSL>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_PostgreSQL__MaybeBackendSSL_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Context> __p_ctx{};
        MaybeBackendSSL();
        MaybeBackendSSL(const MaybeBackendSSL&) = default;
        MaybeBackendSSL(MaybeBackendSSL&&) = default;
        MaybeBackendSSL& operator=(const MaybeBackendSSL&) = default;
        MaybeBackendSSL& operator=(MaybeBackendSSL&&) = default;
        MaybeBackendSSL(std::optional<::hilti::rt::StrongReference<::spicy::rt::Sink>> s1, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> ssl_byte);
        MaybeBackendSSL(::hilti::rt::StrongReference<Context> __p_ctx);
        template<typename F> void __visit(F _) const { _("s1", s1); _("ssl_byte", ssl_byte); }
    };

    struct ProtocolVersion : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ProtocolVersion> {
        auto __self() { return ::hilti::rt::ValueReference<ProtocolVersion>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint16_t>> major{};
        std::optional<::hilti::rt::integer::safe<uint16_t>> minor{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__ProtocolVersion_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ProtocolVersion();
        ProtocolVersion(const ProtocolVersion&) = default;
        ProtocolVersion(ProtocolVersion&&) = default;
        ProtocolVersion& operator=(const ProtocolVersion&) = default;
        ProtocolVersion& operator=(ProtocolVersion&&) = default;
        ProtocolVersion(std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> major, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> minor);
        template<typename F> void __visit(F _) const { _("major", major); _("minor", minor); }
    };

    struct SSLSink : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<SSLSink> {
        auto __self() { return ::hilti::rt::ValueReference<SSLSink>::self(this); }
        std::optional<::hilti::rt::Bytes> chunk{};
        void __on_chunk(const ::hilti::rt::Bytes& __dd);
        void __on_0x25_init();
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        ::spicy::rt::sink::detail::State* __sink{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<SSLSink>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_PostgreSQL__SSLSink_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        SSLSink();
        SSLSink(const SSLSink&) = default;
        SSLSink(SSLSink&&) = default;
        SSLSink& operator=(const SSLSink&) = default;
        SSLSink& operator=(SSLSink&&) = default;
        SSLSink(std::optional<std::optional<::hilti::rt::Bytes>> chunk);
        template<typename F> void __visit(F _) const { _("chunk", chunk); }
    };

    struct StartupParameter : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<StartupParameter> {
        auto __self() { return ::hilti::rt::ValueReference<StartupParameter>::self(this); }
        std::optional<::hilti::rt::Bytes> name{};
        std::optional<::hilti::rt::Bytes> value{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__StartupParameter_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        StartupParameter();
        StartupParameter(const StartupParameter&) = default;
        StartupParameter(StartupParameter&&) = default;
        StartupParameter& operator=(const StartupParameter&) = default;
        StartupParameter& operator=(StartupParameter&&) = default;
        StartupParameter(std::optional<std::optional<::hilti::rt::Bytes>> name, std::optional<std::optional<::hilti::rt::Bytes>> value);
        template<typename F> void __visit(F _) const { _("name", name); _("value", value); }
    };

    struct StartupMessage : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<StartupMessage> {
        auto __self() { return ::hilti::rt::ValueReference<StartupMessage>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint32_t>> length{};
        std::optional<::hilti::rt::ValueReference<ProtocolVersion>> version{};
        std::optional<::hilti::rt::Vector<StartupParameter>> parameters{};
        void __on_0x25_done();
        void __on_0x25_error(const std::string& __except);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_parameters_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<StartupParameter>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_PostgreSQL__StartupMessage_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        StartupMessage();
        StartupMessage(const StartupMessage&) = default;
        StartupMessage(StartupMessage&&) = default;
        StartupMessage& operator=(const StartupMessage&) = default;
        StartupMessage& operator=(StartupMessage&&) = default;
        StartupMessage(std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> length, std::optional<std::optional<::hilti::rt::ValueReference<ProtocolVersion>>> version, std::optional<std::optional<::hilti::rt::Vector<StartupParameter>>> parameters);
        template<typename F> void __visit(F _) const { _("length", length); _("version", version); _("parameters", parameters); }
    };

    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::AuthenticationRequest& x) -> std::ostream&;
    extern void __hook_AuthenticationRequest___on_identifier(const ::hilti::rt::integer::safe<uint32_t>& __dd, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::AuthenticationRequest>& __self);
    extern void __hook_AuthenticationRequest___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::AuthenticationRequest>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::AuthenticationResponse& x) -> std::ostream&;
    extern void __hook_AuthenticationResponse___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::AuthenticationResponse>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::BackendKeyData& x) -> std::ostream&;
    extern void __hook_BackendKeyData___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::BackendKeyData>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::DataRow& x) -> std::ostream&;
    extern void __hook_DataRow___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::DataRow>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ErrorIdentifiedField& x) -> std::ostream&;
    extern void __hook_ErrorIdentifiedField___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::ErrorIdentifiedField>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ErrorResponse& x) -> std::ostream&;
    extern void __hook_ErrorResponse___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::ErrorResponse>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::NotImplemented& x) -> std::ostream&;
    extern void __hook_NotImplemented___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::NotImplemented>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::NoticeIdentifiedField& x) -> std::ostream&;
    extern void __hook_NoticeIdentifiedField___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::NoticeIdentifiedField>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::NoticeResponse& x) -> std::ostream&;
    extern void __hook_NoticeResponse___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::NoticeResponse>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ParameterStatus& x) -> std::ostream&;
    extern void __hook_ParameterStatus___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::ParameterStatus>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ReadyForQuery& x) -> std::ostream&;
    extern void __hook_ReadyForQuery___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::ReadyForQuery>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::BackendMessage& x) -> std::ostream&;
    extern void __hook_BackendMessage___on_0x25_error(const std::string& __except, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::BackendMessage>& __self);
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_postgresql::PostgreSQL::SSLBackendState x, adl::tag) -> std::string;
}

namespace __hlt_postgresql::PostgreSQL {
    inline auto operator<<(std::ostream& o, SSLBackendState x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_postgresql::PostgreSQL::SSLFrontendState x, adl::tag) -> std::string;
}

namespace __hlt_postgresql::PostgreSQL {
    inline auto operator<<(std::ostream& o, SSLFrontendState x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::Context& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::SimpleQuery& x) -> std::ostream&;
    extern void __hook_SimpleQuery___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::SimpleQuery>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::Terminate& x) -> std::ostream&;
    extern void __hook_Terminate___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::Terminate>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::FrontendMessage& x) -> std::ostream&;
    extern void __hook_FrontendMessage___on_0x25_error(const std::string& __except, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::FrontendMessage>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::MaybeBackendSSL& x) -> std::ostream&;
    extern void __hook_MaybeBackendSSL___on_ssl_byte(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::MaybeBackendSSL>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::ProtocolVersion& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::SSLSink& x) -> std::ostream&;
    extern void __hook_SSLSink___on_chunk(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::SSLSink>& __self);
    extern void __hook_SSLSink___on_0x25_init(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::SSLSink>& __self);
    extern void __hook_SSLSink___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::SSLSink>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::StartupParameter& x) -> std::ostream&;
    extern void __hook_StartupParameter___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::StartupParameter>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_postgresql::PostgreSQL::StartupMessage& x) -> std::ostream&;
    extern void __hook_StartupMessage___on_0x25_done(::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::StartupMessage>& __self);
    extern void __hook_StartupMessage___on_0x25_error(const std::string& __except, ::hilti::rt::ValueReference<__hlt_postgresql::PostgreSQL::StartupMessage>& __self);
}

namespace zeek::spicy::rt {
    extern void reject_protocol(const std::string& reason);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_BackendMessage___on_0x25_error_f140(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::BackendMessage>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_BackendMessage___on_0x25_error(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::BackendMessage>& __self);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_BackendMessage___on_0x25_error_f140(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::BackendMessage>& __self);
    extern void __hook_FrontendMessage___on_0x25_error_c89f(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::FrontendMessage>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_FrontendMessage___on_0x25_error(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::FrontendMessage>& __self);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_FrontendMessage___on_0x25_error_c89f(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::FrontendMessage>& __self);
}

namespace zeek::spicy::rt {
    extern void confirm_protocol();
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_MaybeBackendSSL___on_ssl_byte_50ce(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<PostgreSQL::MaybeBackendSSL>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_MaybeBackendSSL___on_ssl_byte(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<PostgreSQL::MaybeBackendSSL>& __self);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_MaybeBackendSSL___on_ssl_byte_50ce(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<PostgreSQL::MaybeBackendSSL>& __self);
}

namespace zeek::spicy::rt {
    extern void protocol_end();
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_SSLSink___on_0x25_done_dfa(::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_SSLSink___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_SSLSink___on_0x25_done_dfa(::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self);
}

namespace zeek::spicy::rt {
    extern void protocol_begin(const std::optional<std::string>& analyzer, const ::hilti::rt::Protocol& protocol);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_SSLSink___on_0x25_init_361(::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_SSLSink___on_0x25_init(::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_SSLSink___on_0x25_init_361(::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self);
}

namespace zeek::spicy::rt {
    extern auto is_orig() -> ::hilti::rt::Bool;
}

namespace zeek::spicy::rt {
    extern void protocol_data_in(const ::hilti::rt::Bool& is_orig, const ::hilti::rt::Bytes& data, const ::hilti::rt::Protocol& protocol);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_SSLSink___on_chunk_3100(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_SSLSink___on_chunk(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_SSLSink___on_chunk_3100(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self);
    extern void __hook_StartupMessage___on_0x25_done_114d(::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_StartupMessage___on_0x25_done(::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_StartupMessage___on_0x25_done_114d(::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self);
    extern void __hook_StartupMessage___on_0x25_error_f7d1(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self);
}

namespace __hlt_postgresql::PostgreSQL {
    extern void __hook_StartupMessage___on_0x25_error(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self);
}

namespace __hlt_postgresql::PostgreSQL_Zeek {
    extern void __hook_StartupMessage___on_0x25_error_f7d1(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self);
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_postgresql::PostgreSQL_Zeek::__register_module)

inline void __hlt_postgresql::PostgreSQL::AuthenticationRequest::__on_0x25_done() {
    auto __self = PostgreSQL::AuthenticationRequest::__self();
    return __hlt_postgresql::PostgreSQL::__hook_AuthenticationRequest___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::AuthenticationRequest::__on_identifier(const ::hilti::rt::integer::safe<uint32_t>& __dd) {
    auto __self = PostgreSQL::AuthenticationRequest::__self();
    return __hlt_postgresql::PostgreSQL::__hook_AuthenticationRequest___on_identifier(__dd, __self);
}

inline void __hlt_postgresql::PostgreSQL::AuthenticationResponse::__on_0x25_done() {
    auto __self = PostgreSQL::AuthenticationResponse::__self();
    return __hlt_postgresql::PostgreSQL::__hook_AuthenticationResponse___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::BackendKeyData::__on_0x25_done() {
    auto __self = PostgreSQL::BackendKeyData::__self();
    return __hlt_postgresql::PostgreSQL::__hook_BackendKeyData___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::BackendMessage::__on_0x25_error(const std::string& __except) {
    auto __self = PostgreSQL::BackendMessage::__self();
    return __hlt_postgresql::PostgreSQL::__hook_BackendMessage___on_0x25_error(__except, __self);
}

inline void __hlt_postgresql::PostgreSQL::DataRow::__on_0x25_done() {
    auto __self = PostgreSQL::DataRow::__self();
    return __hlt_postgresql::PostgreSQL::__hook_DataRow___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::ErrorIdentifiedField::__on_0x25_done() {
    auto __self = PostgreSQL::ErrorIdentifiedField::__self();
    return __hlt_postgresql::PostgreSQL::__hook_ErrorIdentifiedField___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::ErrorResponse::__on_0x25_done() {
    auto __self = PostgreSQL::ErrorResponse::__self();
    return __hlt_postgresql::PostgreSQL::__hook_ErrorResponse___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::FrontendMessage::__on_0x25_error(const std::string& __except) {
    auto __self = PostgreSQL::FrontendMessage::__self();
    return __hlt_postgresql::PostgreSQL::__hook_FrontendMessage___on_0x25_error(__except, __self);
}

inline void __hlt_postgresql::PostgreSQL::MaybeBackendSSL::__on_ssl_byte(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = PostgreSQL::MaybeBackendSSL::__self();
    return __hlt_postgresql::PostgreSQL::__hook_MaybeBackendSSL___on_ssl_byte(__dd, __self);
}

inline void __hlt_postgresql::PostgreSQL::NotImplemented::__on_0x25_done() {
    auto __self = PostgreSQL::NotImplemented::__self();
    return __hlt_postgresql::PostgreSQL::__hook_NotImplemented___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::NoticeIdentifiedField::__on_0x25_done() {
    auto __self = PostgreSQL::NoticeIdentifiedField::__self();
    return __hlt_postgresql::PostgreSQL::__hook_NoticeIdentifiedField___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::NoticeResponse::__on_0x25_done() {
    auto __self = PostgreSQL::NoticeResponse::__self();
    return __hlt_postgresql::PostgreSQL::__hook_NoticeResponse___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::ParameterStatus::__on_0x25_done() {
    auto __self = PostgreSQL::ParameterStatus::__self();
    return __hlt_postgresql::PostgreSQL::__hook_ParameterStatus___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::ReadyForQuery::__on_0x25_done() {
    auto __self = PostgreSQL::ReadyForQuery::__self();
    return __hlt_postgresql::PostgreSQL::__hook_ReadyForQuery___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::SSLSink::__on_0x25_done() {
    auto __self = PostgreSQL::SSLSink::__self();
    return __hlt_postgresql::PostgreSQL::__hook_SSLSink___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::SSLSink::__on_0x25_init() {
    auto __self = PostgreSQL::SSLSink::__self();
    return __hlt_postgresql::PostgreSQL::__hook_SSLSink___on_0x25_init(__self);
}

inline void __hlt_postgresql::PostgreSQL::SSLSink::__on_chunk(const ::hilti::rt::Bytes& __dd) {
    auto __self = PostgreSQL::SSLSink::__self();
    return __hlt_postgresql::PostgreSQL::__hook_SSLSink___on_chunk(__dd, __self);
}

inline void __hlt_postgresql::PostgreSQL::SimpleQuery::__on_0x25_done() {
    auto __self = PostgreSQL::SimpleQuery::__self();
    return __hlt_postgresql::PostgreSQL::__hook_SimpleQuery___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::StartupMessage::__on_0x25_done() {
    auto __self = PostgreSQL::StartupMessage::__self();
    return __hlt_postgresql::PostgreSQL::__hook_StartupMessage___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::StartupMessage::__on_0x25_error(const std::string& __except) {
    auto __self = PostgreSQL::StartupMessage::__self();
    return __hlt_postgresql::PostgreSQL::__hook_StartupMessage___on_0x25_error(__except, __self);
}

inline void __hlt_postgresql::PostgreSQL::StartupParameter::__on_0x25_done() {
    auto __self = PostgreSQL::StartupParameter::__self();
    return __hlt_postgresql::PostgreSQL::__hook_StartupParameter___on_0x25_done(__self);
}

inline void __hlt_postgresql::PostgreSQL::Terminate::__on_0x25_done() {
    auto __self = PostgreSQL::Terminate::__self();
    return __hlt_postgresql::PostgreSQL::__hook_Terminate___on_0x25_done(__self);
}

inline auto __hlt_postgresql::PostgreSQL::operator<<(std::ostream& o, SSLBackendState x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_postgresql::PostgreSQL::operator<<(std::ostream& o, SSLFrontendState x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern void __hlt_postgresql::PostgreSQL_Zeek::__hook_BackendMessage___on_0x25_error_f140(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::BackendMessage>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql_zeek.spicy:42:5-42:69");
    ::zeek::spicy::rt::reject_protocol(::hilti::rt::fmt(std::string("error while parsing PostgreSQL: %s"), msg));
}

extern void __hlt_postgresql::PostgreSQL_Zeek::__hook_FrontendMessage___on_0x25_error_c89f(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::FrontendMessage>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql_zeek.spicy:38:5-38:69");
    ::zeek::spicy::rt::reject_protocol(::hilti::rt::fmt(std::string("error while parsing PostgreSQL: %s"), msg));
}

extern void __hlt_postgresql::PostgreSQL_Zeek::__hook_MaybeBackendSSL___on_ssl_byte_50ce(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<PostgreSQL::MaybeBackendSSL>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql_zeek.spicy:17:5-17:28");
    ::zeek::spicy::rt::confirm_protocol();
}

extern void __hlt_postgresql::PostgreSQL_Zeek::__hook_SSLSink___on_0x25_done_dfa(::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql_zeek.spicy:25:5-25:24");
    ::zeek::spicy::rt::protocol_end();
}

extern void __hlt_postgresql::PostgreSQL_Zeek::__hook_SSLSink___on_0x25_init_361(::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql_zeek.spicy:21:5-21:31");
    ::zeek::spicy::rt::protocol_begin(std::optional<std::string>(std::string("SSL")), ::hilti::rt::Protocol{::hilti::rt::Protocol::TCP});
}

extern void __hlt_postgresql::PostgreSQL_Zeek::__hook_SSLSink___on_chunk_3100(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<PostgreSQL::SSLSink>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql_zeek.spicy:30:5-30:55");
    ::zeek::spicy::rt::protocol_data_in(::zeek::spicy::rt::is_orig(), ::hilti::rt::optional::value((*__self).chunk), ::hilti::rt::Protocol{::hilti::rt::Protocol::TCP});
}

extern void __hlt_postgresql::PostgreSQL_Zeek::__hook_StartupMessage___on_0x25_done_114d(::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql_zeek.spicy:11:5-11:28");
    ::zeek::spicy::rt::confirm_protocol();
}

extern void __hlt_postgresql::PostgreSQL_Zeek::__hook_StartupMessage___on_0x25_error_f7d1(const std::string& msg, ::hilti::rt::ValueReference<PostgreSQL::StartupMessage>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/postgresql/postgresql_zeek.spicy:34:5-34:84");
    ::zeek::spicy::rt::reject_protocol(::hilti::rt::fmt(std::string("error while parsing PostgreSQL StartupMessage: %s"), msg));
}

extern void __hlt_postgresql::PostgreSQL_Zeek::__register_module() { ::hilti::rt::detail::registerModule({ "PostgreSQL_Zeek", __hlt_postgresql_hlto_scope, nullptr, nullptr, nullptr, nullptr}); }

inline auto hilti::rt::detail::adl::to_string(__hlt_postgresql::PostgreSQL::SSLBackendState x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_postgresql::PostgreSQL::SSLBackendState::N: return "SSLBackendState::N";
        case __hlt_postgresql::PostgreSQL::SSLBackendState::S: return "SSLBackendState::S";
        case __hlt_postgresql::PostgreSQL::SSLBackendState::Undef: return "SSLBackendState::Undef";
        default: return ::hilti::rt::fmt("SSLBackendState::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_postgresql::PostgreSQL::SSLFrontendState x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_postgresql::PostgreSQL::SSLFrontendState::NotRequested: return "SSLFrontendState::NotRequested";
        case __hlt_postgresql::PostgreSQL::SSLFrontendState::Requested: return "SSLFrontendState::Requested";
        case __hlt_postgresql::PostgreSQL::SSLFrontendState::Undef: return "SSLFrontendState::Undef";
        default: return ::hilti::rt::fmt("SSLFrontendState::<unknown-%" PRIu64 ">", x.value());
    }
}

